Index: branches/powerups/src/lib/parser/ini_parser/ini_parser.cc
===================================================================
--- branches/powerups/src/lib/parser/ini_parser/ini_parser.cc	(revision 5955)
+++ branches/powerups/src/lib/parser/ini_parser/ini_parser.cc	(revision 5955)
@@ -0,0 +1,771 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: Christian Meyer
+
+   2005-08-14: complete reimplementation:
+               now the File is parsed at the initialisation,
+               and informations is gathered there.
+*/
+
+
+#include "ini_parser.h"
+
+#include <stdlib.h>
+#include <string.h>
+
+#if HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#ifdef DEBUG
+ #include "../../../defs/debug.h"
+#else
+ #define PRINTF(x) printf
+#endif
+
+using namespace std;
+
+/**
+ * @brief constructs an IniParser using a file
+ * @param fileName: the path and name of the file to parse
+ */
+IniParser::IniParser (const char* fileName)
+{
+  this->fileName = NULL;
+  this->comment = NULL;
+
+  if (fileName != NULL)
+    this->readFile(fileName);
+}
+
+
+/**
+ * @brief removes the IniParser from memory
+ */
+IniParser::~IniParser ()
+{
+  this->deleteSections();
+  this->setFileName(NULL);
+}
+
+
+/**
+ * @brief removes all the sections. This is like delete, but even cooler :)
+ */
+void IniParser::deleteSections()
+{
+  // in all sections
+  while(!this->sections.empty())
+  {
+     IniSection section = this->sections.front();
+
+    // in all entries of the sections
+    while(!section.entries.empty())
+    {
+      // delete all strings of entries.
+      IniEntry entry = section.entries.front();
+      delete[] entry.name;
+      delete[] entry.value;
+      delete[] entry.comment;
+      section.entries.pop_front();
+    }
+    // delete all Sections
+    delete[] section.name;
+    delete[] section.comment;
+    this->sections.pop_front();
+  }
+  this->currentSection = this->sections.end();
+  this->setFileName(NULL);
+}
+
+
+/**
+ * @brief sets the Name of the input-file
+ * @param fileName The new FileName to set to the IniParser
+ * If fileName is NULL the new Name will be set to NULL too.
+ */
+void IniParser::setFileName(const char* fileName)
+{
+  if (this->fileName != NULL)
+    delete[] this->fileName;
+  if  (this->comment != NULL)
+    delete[] this->comment;
+  this->comment = NULL;
+
+  if (fileName != NULL)
+  {
+    this->fileName = new char[strlen(fileName)+1];
+    strcpy(this->fileName, fileName);
+  }
+  else
+    this->fileName = NULL;
+}
+
+
+/**
+ * @brief opens a file to parse
+ * @param fileName: path and name of the new file to parse
+ * @return true on success false otherwise;
+ *
+ * If there was already an opened file, the file will be closed,
+ * and the new one will be opened.
+ */
+bool IniParser::readFile(const char* fileName)
+{
+  FILE*    stream;           //< The stream we use to read the file.
+  int      lineCount = 0;    //< The Count of lines.
+
+  if (this->fileName != NULL)
+    this->deleteSections();
+  if( fileName == NULL)
+    return false;
+
+  if( (stream = fopen (fileName, "r")) == NULL)
+  {
+    PRINTF(1)("IniParser could not open %s\n", fileName);
+    return false;
+  }
+  else
+  {
+    this->setFileName(fileName);
+
+    /////////////////////////////
+    // READING IN THE INI-FILE //
+    /////////////////////////////
+    char lineBuffer[PARSELINELENGHT];
+    char buffer[PARSELINELENGHT];
+    const char* lineBegin;
+    char* ptr;
+
+    while( fgets (lineBuffer, PARSELINELENGHT, stream))
+    {
+      lineBegin = lineBuffer;
+      // remove newline char, and \0-terminate
+      if( (ptr = strchr( lineBuffer, '\n')) != NULL)
+        *ptr = 0;
+      // cut up to the beginning of the line.
+      while((*lineBegin == ' ' || *lineBegin == '\t') && lineBegin < lineBuffer + strlen(lineBuffer))
+        ++lineBegin;
+
+      // check if we have a FileComment
+      if ( (*lineBegin == '#' || *lineBegin == ';'))
+      {
+        char* newCommenLine = new char[strlen(lineBegin)+1];
+        strcpy(newCommenLine, lineBegin);
+        this->commentList.push_back(newCommenLine);
+        continue;
+      }
+      if (lineCount == 0 && !this->commentList.empty())
+      {
+        this->setFileComment();
+        lineCount++;
+      }
+
+      // check for section identifyer
+      else if( sscanf (lineBegin, "[%s", buffer) == 1)
+      {
+        if( (ptr = strchr( buffer, ']')) != NULL)
+        {
+          *ptr = 0;
+          this->addSection(buffer);
+          this->setSectionComment();
+        }
+      }
+      // check for Entry identifier (Entry = Value)
+      else if( (ptr = strchr( lineBegin, '=')) != NULL)
+      {
+        if (currentSection == NULL)
+        {
+          PRINTF(2)("Not in a Section yet for %s\n", lineBegin);
+          lineCount++;
+          continue;
+        }
+        if( ptr == lineBegin) {
+          lineCount++;
+          continue;
+        }
+        char* valueBegin = ptr+1;
+        while ((*valueBegin == ' ' || *valueBegin == '\t') && valueBegin <= lineBegin + strlen(lineBegin))
+          ++valueBegin;
+        char* valueEnd = valueBegin + strlen(valueBegin)-1;
+        while ((*valueEnd == ' ' || *valueEnd == '\t') && valueEnd >= valueBegin)
+          --valueEnd;
+        valueEnd[1] = '\0';
+        char* nameEnd = ptr-1;
+        while ((*nameEnd == ' ' || *nameEnd == '\t' ) && nameEnd >= lineBegin)
+          --nameEnd;
+        nameEnd[1] = '\0';
+
+        this->addVar(lineBegin, valueBegin);
+        this->setEntryComment();
+
+        lineCount++;
+      }
+    }
+  }
+  this->currentSection = this->sections.begin();
+  if (!this->sections.empty())
+    this->currentEntry = (*this->currentSection).entries.begin();
+
+  fclose(stream);
+  return true;
+}
+
+
+/**
+ * @brief opens a file and writes to it
+ * @param fileName: path and name of the new file to write to
+ * @return true on success false otherwise
+ */
+bool IniParser::writeFile(const char* fileName) const
+{
+  FILE*    stream;           //!< The stream we use to read the file.
+  if( fileName == NULL && (fileName = this->fileName) == NULL )
+    return false;
+
+  if( (stream = fopen (fileName, "w")) == NULL)
+  {
+    PRINTF(1)("IniParser could not open %s\n", fileName);
+    return false;
+  }
+  else
+  {
+    if (this->comment != NULL)
+      fprintf(stream, "%s\n\n", this->comment);
+
+    std::list<IniSection>::const_iterator section;
+    for (section = this->sections.begin(); section != this->sections.end(); section++)
+      {
+        if ((*section).comment != NULL)
+          fprintf(stream, "%s", (*section).comment);
+        fprintf(stream, "\n [%s]\n", (*section).name);
+
+        std::list<IniEntry>::const_iterator entry;
+        for (entry = (*section).entries.begin(); entry != (*section).entries.end(); entry++)
+        {
+          if ((*entry).comment != NULL)
+            fprintf(stream, "%s", (*entry).comment);
+          fprintf(stream, "   %s = %s\n", (*entry).name, (*entry).value);
+         }
+      }
+  }
+  fclose(stream);
+}
+
+void IniParser::setFileComment(const char* fileComment)
+{
+  if (this->comment != NULL)
+    delete this->comment;
+
+  if (fileComment != NULL)
+  {
+    this->comment = new char[strlen(fileComment)+1];
+    strcpy(this->comment, fileComment);
+  }
+  else
+    this->comment = NULL;
+}
+
+
+/**
+ * @brief adds a section to the list of Sections,
+ * if no Section list is availiable, it will create it
+ * @param sectionName the Name of the section to add
+ * @return true on success... there is only success or segfault :)
+ */
+bool IniParser::addSection(const char* sectionName)
+{
+  if (sectionName == NULL)
+    return false;
+  this->sections.push_back(IniSection());
+  this->sections.back().comment = NULL;
+  this->sections.back().name = new char[strlen(sectionName)+1];
+  strcpy(this->sections.back().name, sectionName);
+
+  this->currentSection = --this->sections.end();
+  if (!this->sections.empty())
+      this->currentEntry = (*this->currentSection).entries.begin();
+  PRINTF(5)("Added Section %s\n", sectionName);
+  return true;
+}
+
+
+/**
+ * @brief Set the parsing cursor to the specified section
+ * @param sectionName: the name of the section to set the cursor to
+ * @return true on success or false if the section could not be found
+ */
+bool IniParser::getSection(const char* sectionName)
+{
+  this->currentSection = this->getSectionIT(sectionName);
+  if (this->currentSection != this->sections.end())
+  {
+    this->currentEntry = (*this->currentSection).entries.begin();
+    return true;
+  }
+  else
+    return false;
+}
+
+/**
+ *
+ */
+void IniParser::setSectionComment(const char* comment, const char* sectionName)
+{
+  std::list<IniSection>::iterator section = this->getSectionIT(sectionName);
+  if (section == this->sections.end())
+    return;
+
+  if ((*section).comment != NULL)
+    delete[] (*section).comment;
+  if (comment != NULL)
+  {
+    (*section).comment = new char[strlen (comment)+1];
+    strcpy((*section).comment, comment);
+  }
+  else
+    (*section).comment = NULL;
+}
+
+/**
+ * @param sectionName the Section to query for
+ * @returns the Comment, or NULL on error.
+ */
+const char* IniParser::getSectionComment(const char* sectionName) const
+{
+  std::list<IniSection>::const_iterator section = this->getSectionIT(sectionName);
+  if (section != this->sections.end())
+    return (*section).comment;
+  else
+    return NULL;
+}
+
+
+/**
+ * @brief moves to the first section
+ */
+void IniParser::firstSection()
+{
+  this->currentSection = this->sections.begin();
+  if (!this->sections.empty())
+    this->currentEntry = (*this->currentSection).entries.begin();
+}
+
+
+/**
+ * @brief searches the next section
+ * @returns the name of the section if found, NULL otherwise
+ */
+const char* IniParser::nextSection()
+{
+  if (this->currentSection == this->sections.end())
+    return NULL;
+
+  this->currentSection++;
+
+  if (this->currentSection != this->sections.end())
+    {
+      this->currentEntry = (*this->currentSection).entries.begin();
+      return this->currentSection->name;
+    }
+  else
+    return NULL;
+}
+
+
+/**
+ * @brief adds a new Entry to either the currentSection or the section called by sectionName
+ * @param entryName the Name of the Entry to add
+ * @param value the value to assign to this entry
+ * @param sectionName if NULL then this entry will be set to the currentSection
+ * otherwise to the section refered to by sectionName.
+ * If both are NULL no entry will be added
+ * @return true if everything is ok false on error
+ */
+bool IniParser::addVar(const char* entryName, const char* value, const char* sectionName)
+{
+  std::list<IniSection>::iterator section;
+
+  if (sectionName != NULL)
+  {
+    for (section = this->sections.begin(); section != this->sections.end(); section++)
+      if (!strcmp((*section).name, sectionName))
+        break;
+  }
+  else
+    section = this->currentSection;
+
+  if (section == this->sections.end())
+    return false;
+
+  if (section == this->sections.end())
+  {
+    PRINTF(2)("section '%s' not found for value '%s'\n", sectionName, entryName);
+    return false;
+  }
+  else
+  {
+    (*section).entries.push_back(IniEntry());
+    (*section).entries.back().comment = NULL;
+    (*section).entries.back().name = new char[strlen(entryName)+1];
+    strcpy((*section).entries.back().name, entryName);
+    (*section).entries.back().value = new char[strlen(value)+1];
+    strcpy((*section).entries.back().value, value);
+    PRINTF(5)("Added Entry %s with Value '%s' to Section %s\n",
+              (*section).entries.back().name,
+              (*section).entries.back().value,
+              (*section).name);
+    this->currentEntry = --(*section).entries.end();
+    return true;
+  }
+}
+
+
+/**
+ * @brief directly acesses an entry in a section
+ * @param entryName: the name of the entry to find
+ * @param sectionName: the section where the entry is to be found
+ * @param defaultValue: what should be returned in case the entry cannot be found
+ * @return a pointer to a buffer conatining the value of the specified entry. This buffer will contain the data specified in defvalue in case the entry wasn't found
+ *
+ *  The returned pointer points to an internal buffer, so do not free it on your own. Do not give a NULL pointer to defvalue, this will certainly
+ * lead to unwanted behaviour.
+*/
+const char* IniParser::getVar(const char* entryName, const char* sectionName, const char* defaultValue) const
+{
+  if (this->fileName != NULL)
+  {
+    std::list<IniEntry>::const_iterator entry = this->getEntryIT(entryName, sectionName);
+    if (entry != NULL &&  !strcmp((*entry).name, entryName))
+      return (*entry).value;
+    PRINTF(2)("Entry '%s' in section '%s' not found.\n", entryName, sectionName);
+
+  }
+  else
+    PRINTF(2)("no File opened\n");
+
+  return defaultValue;
+
+}
+
+/**
+ * Set the Comment of a specified Entry.
+ * @param comment the Comment to set
+ * @param entryName the Name of the Entry
+ * @param sectionName the Name of the Section
+ */
+void IniParser::setEntryComment(const char* comment, const char* entryName, const char* sectionName)
+{
+  std::list<IniEntry>::iterator entry = this->getEntryIT(entryName, sectionName);
+
+  if ((*entry).comment != NULL)
+    delete[] (*entry).comment;
+  if (comment != NULL)
+  {
+    (*entry).comment = new char[strlen (comment)+1];
+    strcpy((*entry).comment, comment);
+  }
+  else
+    (*entry).comment = NULL;
+
+
+}
+
+/**
+ * @param entryName the Entry to query for
+ * @param sectionName the Section to Query for
+ * @returns the queried Comment.
+ */
+const char* IniParser::getEntryComment(const char* entryName, const char* sectionName) const
+{
+  std::list<IniEntry>::const_iterator entry = this->getEntryIT(entryName, sectionName);
+
+  return (*entry).comment;
+}
+
+
+/**
+ * @brief moves to the first Variable of the current Section
+ */
+void IniParser::firstVar()
+{
+  if (!this->sections.empty() &&
+       this->currentSection != this->sections.end())
+    this->currentEntry = (*this->currentSection).entries.begin();
+}
+
+
+/**
+ * @brief gets the next VarName = VarValue pair from the parsing stream
+ * @return true on success, false otherwise (in the latter case name and value will be NULL)
+ */
+bool IniParser::nextVar()
+{
+  if ( this->sections.empty()
+       || this->currentSection == this->sections.end()
+       || this->currentEntry == (*this->currentSection).entries.end())
+    return false;
+
+  this->currentEntry++;
+
+  if (this->currentEntry == (*this->currentSection).entries.end())
+    return false;
+  else
+    return true;
+}
+
+
+
+/**
+ * @returns the name of the Current selected Section
+ */
+const char* IniParser::getCurrentSection() const
+{
+  if (!this->sections.empty() &&
+      this->currentSection != this->sections.end())
+    return this->currentSection->name;
+  else
+    return NULL;
+ }
+
+
+/**
+ * @returns the current entries Name, or NULL if we havn't selected a Entry
+ */
+const char* IniParser::getCurrentName() const
+{
+ if (!this->sections.empty() &&
+     this->currentSection != this->sections.end() &&
+     this->currentEntry != (*this->currentSection).entries.end())
+   return (*this->currentEntry).name;
+ else
+   return NULL;
+}
+
+/**
+ * @returns the current entries Value, or NULL if we havn't selected a Entry
+ */
+const char* IniParser::getCurrentValue() const
+{
+  if (!this->sections.empty() &&
+      this->currentSection != this->sections.end() &&
+      this->currentEntry != (*this->currentSection).entries.end())
+    return (*this->currentEntry).value;
+  else
+    return NULL;
+}
+
+
+/**
+ * Finds the Section Iterator of the Section Called sectionName
+ * @param sectionName the Name of the Section to get the Iterator from
+ */
+std::list<IniParser::IniSection>::const_iterator IniParser::getSectionIT(const char* sectionName) const
+{
+  std::list<IniSection>::const_iterator section = this->currentSection;
+  if (sectionName == NULL)
+    return this->currentSection;
+  else
+    for (section = this->sections.begin(); section != this->sections.end(); section++)
+      if (!strcmp((*section).name, sectionName))
+        break;
+  return section;
+}
+
+
+/**
+ * Finds the Section Iterator of the Section Called sectionName
+ * @param sectionName the Name of the Section to get the Iterator from
+ */
+std::list<IniParser::IniSection>::iterator IniParser::getSectionIT(const char* sectionName)
+{
+  std::list<IniSection>::iterator section = this->currentSection;
+  if (sectionName == NULL)
+    return this->currentSection;
+  else
+    for (section = this->sections.begin(); section != this->sections.end(); section++)
+      if (!strcmp((*section).name, sectionName))
+        break;
+  return section;
+}
+
+
+/**
+ * Finds the Entry Iterator of the Section Called sectionName and entry called EntryName
+ * @param entryName the Name of the Entry to get the Iterator from
+ * @param sectionName the Name of the Section to get the Iterator from
+ */
+std::list<IniParser::IniEntry>::const_iterator IniParser::getEntryIT(const char* entryName, const char* sectionName) const
+{
+  if (entryName == NULL)
+    return this->currentEntry;
+  std::list<IniSection>::const_iterator section = this->getSectionIT(sectionName);
+  std::list<IniEntry>::const_iterator entry = this->currentEntry;
+
+  if (section != this->sections.end())
+    for (entry = (*section).entries.begin(); entry != (*section).entries.end(); entry++)
+      if (!strcmp((*entry).name, entryName))
+        break;
+  if (entry == (*section).entries.end())
+    return NULL;
+  else
+    return entry;
+}
+
+
+/**
+ * Finds the Entry Iterator of the Section Called sectionName and entry called EntryName
+ * @param entryName the Name of the Entry to get the Iterator from
+ * @param sectionName the Name of the Section to get the Iterator from
+ */
+std::list<IniParser::IniEntry>::iterator IniParser::getEntryIT(const char* entryName, const char* sectionName)
+{
+  if (entryName == NULL)
+    return this->currentEntry;
+  std::list<IniSection>::iterator section = this->getSectionIT(sectionName);
+  std::list<IniEntry>::iterator entry = this->currentEntry;
+
+  if (section != this->sections.end())
+    for (entry = (*section).entries.begin(); entry != (*section).entries.end(); entry++)
+      if (!strcmp((*entry).name, entryName))
+        break;
+  if (entry == (*section).entries.end())
+    return NULL;
+  else
+    return entry;
+}
+
+
+/**
+ * takes lines together to form one FileComment, ereasing the commentList
+ */
+void IniParser::setFileComment()
+{
+  if (this->comment != NULL)
+    delete[] this->comment;
+
+  if (this->commentList.empty()) {
+    this->comment = NULL;
+    return;
+  }
+
+  unsigned int stringLength = 1;
+  std::list<char*>::iterator comment;
+  for (comment = this->commentList.begin(); comment != this->commentList.end(); comment++)
+    stringLength += strlen((*comment)) +1;
+
+  this->comment = new char[stringLength];
+  this->comment[0] = '\0';
+  while (!this->commentList.empty())
+  {
+    if (*this->comment != '\0')
+      strcat(this->comment, "\n");
+    strcat(this->comment, this->commentList.front());
+    delete[] this->commentList.front();
+    this->commentList.pop_front();
+  }
+}
+
+/**
+ * takes lines together to form one SectionComment, ereasing the commentList
+ */
+void IniParser::setSectionComment()
+{
+  if ((*this->currentSection).comment != NULL)
+    delete[] (*this->currentSection).comment;
+
+  if (this->commentList.empty()) {
+    (*this->currentSection).comment = NULL;
+    return;
+  }
+
+  unsigned int stringLength = 1;
+  std::list<char*>::iterator comment;
+  for (comment = this->commentList.begin(); comment != this->commentList.end(); comment++)
+    stringLength += strlen((*comment)) +1;
+
+  (*this->currentSection).comment = new char[stringLength];
+  (*this->currentSection).comment[0] = '\0';
+  while (!this->commentList.empty())
+  {
+    if (*(*this->currentSection).comment != '\0')
+      strcat((*this->currentSection).comment, "\n");
+    strcat((*this->currentSection).comment, this->commentList.front());
+    delete[] this->commentList.front();
+    this->commentList.pop_front();
+  }
+}
+
+/**
+ * takes lines together to form one EntryComment, ereasing the commentList
+ */
+void IniParser::setEntryComment()
+{
+  if ((*this->currentEntry).comment != NULL)
+    delete[] (*this->currentEntry).comment;
+
+  if (this->commentList.empty()) {
+    (*this->currentEntry).comment = NULL;
+    return;
+  }
+
+  unsigned int stringLength = 1;
+  std::list<char*>::iterator comment;
+  for (comment = this->commentList.begin(); comment != this->commentList.end(); comment++)
+    stringLength += strlen((*comment)) +1;
+
+  (*this->currentEntry).comment = new char[stringLength];
+  (*this->currentEntry).comment[0] = '\0';
+  while (!this->commentList.empty())
+  {
+    if (*(*this->currentEntry).comment != '\0')
+      strcat((*this->currentEntry).comment, "\n");
+    strcat((*this->currentEntry).comment, this->commentList.front());
+    delete[] this->commentList.front();
+    this->commentList.pop_front();
+  }
+
+}
+
+
+/**
+ * @brief output the whole tree in a nice and easy way.
+ */
+void IniParser::debug() const
+{
+  PRINTF(0)("Iniparser %s - debug\n", this->fileName);
+  if (this->comment != NULL)
+    PRINTF(0)("FileComment:\n %s\n\n", this->comment);
+
+  if (this->fileName != NULL)
+  {
+    std::list<IniSection>::const_iterator section;
+    for (section = this->sections.begin(); section != this->sections.end(); section++)
+    {
+      if ((*section).comment != NULL)
+        PRINTF(0)(" %s\n", (*section).comment);
+      PRINTF(0)(" [%s]\n", (*section).name);
+
+      std::list<IniEntry>::const_iterator entry;
+      for (entry = (*section).entries.begin(); entry != (*section).entries.end(); entry++)
+      {
+        if ((*entry).comment != NULL)
+          PRINTF(0)(" %s\n", (*entry).comment);
+        PRINTF(0)("   '%s' -> '%s'\n", (*entry).name, (*entry).value);
+      }
+    }
+  }
+  else
+    PRINTF(1)("no opened ini-file.\n");
+}
+
Index: branches/powerups/src/lib/parser/ini_parser/ini_parser.h
===================================================================
--- branches/powerups/src/lib/parser/ini_parser/ini_parser.h	(revision 5955)
+++ branches/powerups/src/lib/parser/ini_parser/ini_parser.h	(revision 5955)
@@ -0,0 +1,112 @@
+/*!
+ * @file ini_parser.h
+ * A small ini file parser
+ *
+ * Can be used to find a defined [Section] in an ini file and get the VarName = Value entries
+ */
+
+#ifndef _INI_PARSER_H
+#define _INI_PARSER_H
+
+#define PARSELINELENGHT     512       //!< how many chars to read at once
+#ifndef NULL
+ #define NULL 0x0                     //!< NULL
+#endif
+
+#include <list>
+
+//! ini-file parser
+/**
+ * This class can be used to load an initializer file and parse it's contents for variablename=value pairs.
+ */
+class IniParser
+{
+  private:
+    ////////////////////////////////////
+    //! a struct for Entries in the Parser's File's Sections
+    struct IniEntry
+    {
+      char*               comment;  //!< A Comment that is appendet to the Top of this Entry.
+      char*               name;     //!< name of a given Entry
+      char*               value;    //!< value of a given Entry
+    };
+
+    //! a struct for Sections in the Parser's file
+    struct IniSection
+    {
+      char*               comment;  //!< A Comment that is appendet to the Top of this Section.
+      char*               name;     //!< name of a given section
+      std::list<IniEntry> entries;  //!< a list of entries for this section
+    };
+    ////////////////////////////////////
+
+  public:
+    IniParser (const char* filename = NULL);
+    ~IniParser ();
+
+    /** @returns true if the file is opened, false otherwise*/
+    bool isOpen() const { return (this->fileName != NULL)? true : false; };
+    /** @returns the fileName we have opened. */
+    const char* getFileName() const { return this->fileName; };
+
+    bool readFile(const char* fileName);
+    bool writeFile(const char* fileName) const;
+
+    void setFileComment(const char* fileComment);
+    const char* getFileComment() const { return this->comment; };
+
+    bool addSection(const char* sectionName);
+    bool getSection(const char* sectionName);
+    void setSectionComment(const char* comment, const char* sectionName);
+    const char* getSectionComment(const char* sectionNane) const;
+
+    // iterate through sections with these Functions
+    void firstSection();
+    const char* nextSection();
+
+
+    bool addVar(const char* entryName, const char* value, const char* sectionName = NULL);
+    const char* getVar(const char* entryName, const char* sectionName, const char* defaultValue = "") const;
+    void setEntryComment(const char* comment, const char* entryName, const char* sectionName);
+    const char* getEntryComment(const char* entryName, const char* sectionName) const;
+
+    // iterate Through Variables with these Functions.
+    void firstVar();
+    bool nextVar();
+
+
+    // retrieving functions when iterating.
+    const char* getCurrentSection() const;
+    const char* getCurrentName() const;
+    const char* getCurrentValue() const;
+
+
+    // maintenance.
+    void debug() const;
+
+
+  private:
+    void deleteSections();
+    void setFileName(const char* fileName);
+
+    void setFileComment();
+    void setSectionComment();
+    void setEntryComment();
+
+    std::list<IniSection>::const_iterator getSectionIT(const char* sectionName) const;
+    std::list<IniSection>::iterator getSectionIT(const char* sectionName);
+
+    std::list<IniEntry>::const_iterator getEntryIT(const char* entryName, const char* sectionName = NULL) const;
+    std::list<IniEntry>::iterator getEntryIT(const char* entryName, const char* sectionName = NULL);
+
+  private:
+    char*                            fileName;        //!< The name of the File that was parsed.
+    char*                            comment;         //!< A Comment for the header of this File.
+    std::list<IniSection>            sections;        //!< a list of all stored Sections of the Parser
+    std::list<IniSection>::iterator  currentSection;  //!< the current selected Section
+    std::list<IniEntry>::iterator    currentEntry;    //!< the current selected entry (in currentSection)
+
+    std::list<char*>                 commentList;     //!< A list of Comments. (this is for temporary saving of Comments, that are inserted in front of Sections/Entries.)
+};
+
+#endif /* _INI_PARSER_H */
Index: branches/powerups/src/lib/parser/tinyxml/Makefile.am
===================================================================
--- branches/powerups/src/lib/parser/tinyxml/Makefile.am	(revision 5955)
+++ branches/powerups/src/lib/parser/tinyxml/Makefile.am	(revision 5955)
@@ -0,0 +1,10 @@
+
+noinst_LIBRARIES = libtinyxml.a 
+
+libtinyxml_a_SOURCES = tinyxml.cc \
+		       tinystr.cc \
+		       tinyxmlerror.cc \
+		       tinyxmlparser.cc
+
+noinst_HEADERS= tinyxml.h \
+		tinystr.h
Index: branches/powerups/src/lib/parser/tinyxml/tinystr.cc
===================================================================
--- branches/powerups/src/lib/parser/tinyxml/tinystr.cc	(revision 5955)
+++ branches/powerups/src/lib/parser/tinyxml/tinystr.cc	(revision 5955)
@@ -0,0 +1,115 @@
+/*
+www.sourceforge.net/projects/tinyxml
+Original file by Yves Berquin.
+
+This software is provided 'as-is', without any express or implied
+warranty. In no event will the authors be held liable for any
+damages arising from the use of this software.
+
+Permission is granted to anyone to use this software for any
+purpose, including commercial applications, and to alter it and
+redistribute it freely, subject to the following restrictions:
+
+1. The origin of this software must not be misrepresented; you must
+not claim that you wrote the original software. If you use this
+software in a product, an acknowledgment in the product documentation
+would be appreciated but is not required.
+
+2. Altered source versions must be plainly marked as such, and
+must not be misrepresented as being the original software.
+
+3. This notice may not be removed or altered from any source
+distribution.
+*/
+
+/*
+ * THIS FILE WAS ALTERED BY Tyge Løvset, 7. April 2005.
+ */
+
+
+#ifndef TIXML_USE_STL
+
+#include "tinystr.h"
+
+// Error value for find primitive
+const TiXmlString::size_type TiXmlString::npos = static_cast< size_type >(-1);
+
+// Null rep.
+TiXmlString::Rep TiXmlString::nullrep_ = { 0, 0, '\0' };
+
+
+void TiXmlString::reserve (size_type cap)
+{
+	if (cap > capacity())
+	{
+		TiXmlString tmp;
+		tmp.init(length(), cap);
+		memcpy(tmp.start(), data(), length());
+		swap(tmp);
+	}
+}
+
+
+TiXmlString& TiXmlString::assign(const char* str, size_type len)
+{
+	size_type cap = capacity();
+	if (len > cap || cap > 3*(len + 8))
+	{
+		TiXmlString tmp;
+		tmp.init(len);
+		memcpy(tmp.start(), str, len);
+		swap(tmp);
+	}
+	else
+	{
+		memmove(start(), str, len);
+		set_size(len);
+	}
+	return *this;
+}
+
+
+TiXmlString& TiXmlString::append(const char* str, size_type len)
+{
+	size_type newsize = length() + len;
+	if (newsize > capacity())
+	{
+		reserve (newsize + capacity());
+	}
+	memmove(finish(), str, len);
+	set_size(newsize);
+	return *this;
+}
+
+
+TiXmlString operator + (const TiXmlString & a, const TiXmlString & b)
+{
+	TiXmlString tmp;
+	tmp.reserve(a.length() + b.length());
+	tmp += a;
+	tmp += b;
+	return tmp;
+}
+
+TiXmlString operator + (const TiXmlString & a, const char* b)
+{
+	TiXmlString tmp;
+	TiXmlString::size_type b_len = static_cast<TiXmlString::size_type>( strlen(b) );
+	tmp.reserve(a.length() + b_len);
+	tmp += a;
+	tmp.append(b, b_len);
+	return tmp;
+}
+
+TiXmlString operator + (const char* a, const TiXmlString & b)
+{
+	TiXmlString tmp;
+	TiXmlString::size_type a_len = static_cast<TiXmlString::size_type>( strlen(a) );
+	tmp.reserve(a_len + b.length());
+	tmp.append(a, a_len);
+	tmp += b;
+	return tmp;
+}
+
+
+#endif	// TIXML_USE_STL
